
////////////////////////////////////////////////////////////////////////////////// 
// Module Name:    lab0
//
// Target Devices: Basys 2 Xilinx Spartan 3E
//
// Tool versions: ISE 14.4 - 14.6
//
// Description: A led that turns on and off every half second.

//////////////////////////////////////////////////////////////////////////////////
module lab0(clk,out,reset);	//Decleration of the module.
	 
//////////////////DECLARE INPUTS AND OUTPUTS HERE/////////////////////
	 
	 
input clk;   //The clock. Basys 2 FPGA clocks at 25/50/100 Mhz depending on configuration.
					//1x/2x/4x 25,000,000 ticks per second default configuration is 50MHz.


input reset; //Reset signal, assigned to one of Basys 2 buttons.

output out;  //The output. In this case the LED specified in the UCF file.



//////////////////DECLARE USER VARIABLES HERE/////////////////////////

parameter clkFreq = 50_000_000; //default 50Mhz, change by jumper.

reg[26:0] cnt; //27 bit counter,to count up to 100,000,000 (maximum possible frequency).

reg ToOut; //Outputs are wires, you can have a reg (out in this case) as an output but it is not recomended.



//////////////////DECLARE HARDWARE HERE//////////////////////////////

assign out = ToOut; //connect wire out to register ToOut.

//Instead of brackets '{' '}' verilog uses "begin" and "end", "module" and "endmodule", "case" and "endcase".

always @(posedge clk)begin				//This block of code is triggered every time
												//					the clock has a positive edge.
if (reset) cnt <= 0;						//Reset counter at reset signal.
	else
	begin
		if(cnt > clkFreq)cnt <= 0;		// 1x/2x/4x 25,000,000 clock ticks for 1 second(depending on freq).
		else cnt <= cnt +1;				// Increases the counter by 1 in each cycle.
		if(cnt > clkFreq/2) ToOut <= 1; //1x/2x/4x 12,500,000 clock ticks = 0.5 second(depending on freq).
		else ToOut <= 0;					//Changing ToOut between 1 and 0 turns on and off the LED.
	end
end 


endmodule //Declare the end of the module.
